Unit SF51R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF12_p, SF49R_p;

function SF51R(P :Real; var IERR :Integer): Real;

implementation

function SF51R(P :Real; var IERR :Integer): Real;
var
XL,XR,FXL,FXR,XRMXL,FT,X,P1 :Real;
const
SYS089 :Real = 1.0E-6;
ZERO :Real = 0.0E0;
SYS059 :Real = 3.4E38;
XMAX :Real = 9.23;
label
_1,_2,_3,_4,_5,_6;
begin
{ Result -    SF51R  FORTRANe }
if ( (P > 0.E0) ) and ( (P < 1.E0) ) 
 then goto _1;
IERR := 65;
Result := SYS059;
goto _5;
_1:
IERR := 0;
XL := -XMAX;
XR := XMAX;
FXL := -P;
FXR := 1.E0-P;
_2:
X := (XL+XR)*0.5;
P1 := SF49R(X);
FT := P1-P;
if ( FT*FXL > ZERO ) 
 then goto _3;
XR := X;
FXR := FT;
goto _4;
_3:
XL := X;
FXL := FT;
_4:
XRMXL := XR-XL;
Result := X;
if ( Abs(FT) <= SYS089 ) 
 then goto _6;
if ( XRMXL <= SYS089*Abs(X) ) 
 then goto _6;
goto _2;
_5:
UTSF12(IERR,51);
_6:
exit;
end;

end.
